apiVersion: apps/v1
kind: StatefulSet
metadata:
  name: {{ .Release.Name }}-federate
  labels:
    app: {{ .Chart.Name }}-federate
    release: {{ .Release.Name }}-federate
spec:
  replicas: {{ .Values.federate.replicas }}
  ordinals:
    start: 1
  serviceName: lemmy-federate
  selector:
    matchLabels:
      app: {{ .Chart.Name }}-federate
      release: {{ .Release.Name }}-federate
  template:
    metadata:
      labels:
        app: {{ .Chart.Name }}-federate
        release: {{ .Release.Name }}-federate
      {{- with .Values.federate.pod.annotations }}
      annotations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
    spec:
      containers:
      - name: {{ .Chart.Name }}
        image: "{{ .Values.core.image.registry }}/{{ .Values.core.image.repository }}:{{ .Values.core.image.tag }}"
        imagePullPolicy: {{ .Values.federate.imagePullPolicy }}
        args:
          - "--federate-process-count={{ .Values.federate.replicas }}"
        {{- with .Values.federate.args }}
          {{- toYaml . | nindent 10 }}
        {{- end }}
        {{- with .Values.federate.env }}
        env: 
          {{- toYaml . | nindent 10 }}
        {{- end }}
        {{- with .Values.federate.envFrom }}
        envFrom: 
          {{- toYaml . | nindent 10 }}
        {{- end }}
        ports:
        - name: http
          containerPort: 8536
        {{- with .Values.federate.livenessProbe }}
        livenessProbe:
          {{- toYaml . | nindent 10 }}
        {{- end }}
        {{- with .Values.federate.readinessProbe }}
        readinessProbe:
          {{- toYaml . | nindent 10 }}
        {{- end }}
        {{- with .Values.federate.resources }}
        resources: 
          {{- toYaml . | nindent 10}}
        {{- end }}
        volumeMounts:
          - name: config
            mountPath: "/config/"
        {{- with .Values.federate.volumeMounts }}
          {{- toYaml . | nindent 10 }}
        {{- end }}
      volumes:
        - name: config
          secret:
            secretName: {{ .Values.federate.configSecret }}
      {{- with .Values.federate.volumes }}
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.federate.securityContext }}
      securityContext:
        {{- toYaml . | nindent 8 }}
      {{- end }}
